#include "opti.h"

// You can change all the numbers for different results
int CLOUD_POINTS =100;
// lambda
double RANDOMNESS = 0.1;
double MY_RAND_MAX = 0.8;
double MY_RAND_MIN = 0.0;
// Learning rate
double LR = 0.01;
// Error rate
double ER = 0.0001;

// La fonction pow() de math.h avait un problème aavec mon Makefile donc je l'ai refaite
// et puis après avoir résolu le problème (emplacement du -lm) afin de pouvoir utiliser
// sqrt() j'ai décidé de la laisser car le nom est mignon
double popow(double v, double w){
    double u=v;
    for(int i=1;i<w;i++){
        v*=u;
    }
    return v;
}

double norm(double u, double v){
    return sqrt(popow(u,2) + popow(v,2));
}

// Génère un double random...
double double_random(double min, double max) 
{
    double my_random;
    my_random = (double)rand()/RAND_MAX*(max-min)+min;
    //printf ( "%f\n", my_random);
    return my_random;
}

double random_point_in_cloud2_5(Point* my_cloud){
    double v = double_random(MY_RAND_MIN, MY_RAND_MAX);;
    for(int i=0;i<CLOUD_POINTS;i++){
        if(v==my_cloud[i].x){
            v =random_point_in_cloud2_5(my_cloud);
        }
    }
    return v;
}

// Créé après cloud_3, version sans bug de cloud_2 (que vous pouvez trouvé dans mes anciens commits)
Point* cloud2_5(double *a, double *b){
    Point * my_cloud = (Point*)malloc(sizeof(Point)*CLOUD_POINTS);
    for(int i=0;i<CLOUD_POINTS;i++){
        Point chosen_point;
        chosen_point.x=random_point_in_cloud2_5(my_cloud);
        double rj = double_random(-RANDOMNESS, RANDOMNESS);
        chosen_point.y = (*a*chosen_point.x)+*b+rj;
        my_cloud[i].x=chosen_point.x;
        my_cloud[i].y=chosen_point.y/(MY_RAND_MAX+RANDOMNESS);
        //printf("\nx = %f | y = %f\n", my_cloud[i].x,my_cloud[i].y);
    }
    return my_cloud;
}


// version 3 du nuage, plus simple, x espacés uniformément
Point* cloud3(double *a, double *b){
    Point * my_cloud = (Point*)malloc(sizeof(Point)*CLOUD_POINTS);
    for(int i=0;i<CLOUD_POINTS;i++){
        my_cloud[i].x=((double)i/(double)CLOUD_POINTS);
        double rj = double_random(-RANDOMNESS, RANDOMNESS);
        my_cloud[i].y = ((*a)*my_cloud[i].x)+(*b)+rj;
    }
    return my_cloud;
}

// Pour comparer le A et B trouvés sur papier VS ceux que le programme a pondu
// Ci-dessous = chiffres choisi au hasard
Point* cloud_test(){
    Point * my_cloud = (Point*)malloc(sizeof(Point)*3);
    FILE *cx;
    cx = fopen ("cloud.xx", "w+");
    my_cloud[0].x = 0.2;
    my_cloud[0].y = 0.2;
    my_cloud[1].x = 0.3;
    my_cloud[1].y = 0.5;
    my_cloud[2].x = 0.8;
    my_cloud[2].y = 0.4;
    for(int i=0;i<CLOUD_POINTS;i++){
        fprintf(cx, "%f %f\n",my_cloud[i].x,my_cloud[i].y);
    }
    fclose(cx);
    return my_cloud;
}

double gradient(double *a, double *b, Point* my_cloud, int cloud_size, bool is_a){
    double my_gradient;
    for(int i = 0;i<cloud_size;i++){
        //Somme des Xi(aXi+b-Yi)
        if(is_a){
            my_gradient+=(my_cloud[i].x)*((*a*(my_cloud[i].x)+*b-(my_cloud[i].y)));
        //Somme des aXi+b-Yi
        }else{
            my_gradient+=(*a*(my_cloud[i].x))+*b-(my_cloud[i].y);
        }
    }
    return my_gradient;
}

void gradient_descent_v4(double *a, double *b, Point* my_cloud, int my_cloud_size, double* current_cost){
    double gr_A,gr_B,my_new_a,my_new_b;
    double *zero; double z = 0.0; zero = &z;
    *current_cost = cost2(zero,zero,a,b);
    //int nb_it = 0;
    while(*current_cost>ER){
        gr_A = gradient(a, b, my_cloud, my_cloud_size, true);
        gr_B = gradient(a, b, my_cloud, my_cloud_size, false);
        my_new_a = (*a) - (LR * gr_A);
        //printf("\nNew A : %f\n", my_new_a);
        my_new_b = (*b) - (LR * gr_B);
        //printf("New B : %f\n", my_new_b);
        *current_cost = cost2(a,b,&my_new_a,&my_new_b);
        //printf("\nCost : %f\n", current_cost);
        *a = my_new_a; *b = my_new_b;
        //current_cost = cost(a, b, my_cloud, CLOUD_POINTS);
        //nb_it++;
    }
    // Décommentez pour afficher le cost (erreur qui a finalement été autorisée)
    //printf("\nCost : %g || Nombre d'itérations : %d\n ", *current_cost, nb_it);
}

double cost2(double *a, double *b, double *new_a, double *new_b){
    return norm((*new_a - *a),(*new_b - *b));
} 

Point** cloud_splitter(Point* my_cloud){
    Point ** tiny_clouds = malloc(sizeof(Point*)*3);
    Point * g1 = (Point*)malloc(sizeof(Point)*(CLOUD_POINTS/3));
    Point * g2 = (Point*)malloc(sizeof(Point)*((CLOUD_POINTS/3)));
    Point * g3 = (Point*)malloc(sizeof(Point)*(CLOUD_POINTS-((CLOUD_POINTS*2)/3)));

    FILE *ca;
    ca = fopen ("cloud.aa", "w+");
    FILE *cb;
    cb = fopen ("cloud.bb", "w+");
    FILE *cc;
    cc = fopen ("cloud.cc", "w+");

    // Pas besoin de shuffle les points ici car déjà fait dans cloud2_5()
    for(int i=0;i<CLOUD_POINTS;i++){
        if(i<(CLOUD_POINTS/3)){
            g1[i]=my_cloud[i];
            fprintf(ca, "%f %f\n",my_cloud[i].x,my_cloud[i].y);
        }else if(i>=(CLOUD_POINTS/3) && i<((CLOUD_POINTS*2)/3)){
            g2[i-(CLOUD_POINTS/3)]=my_cloud[i];
            fprintf(cb, "%f %f\n",my_cloud[i].x,my_cloud[i].y);
        }else{
            g3[i-((CLOUD_POINTS*2)/3)]=my_cloud[i];
            fprintf(cc, "%f %f\n",my_cloud[i].x,my_cloud[i].y);
        }
    }
    fclose(ca);
    fclose(cb);
    fclose(cc);
    tiny_clouds[0]=g1;
    tiny_clouds[1]=g2;
    tiny_clouds[2]=g3;
    //free(g1);free(g2);free(g3);
    return tiny_clouds;

}

Point* cloud_merger(Point* cloud_a, Point* cloud_b, bool g3_here){
    int cloud_size;
    if(!g3_here){
        cloud_size = (2*CLOUD_POINTS)/3;
    }else{
        cloud_size = CLOUD_POINTS-(CLOUD_POINTS/3);
    }
    Point* merged_cloud = (Point*)malloc(sizeof(Point)*cloud_size);
    for(int i=0;i<cloud_size;i++){
        if(i<(CLOUD_POINTS/3)){
            merged_cloud[i]=cloud_a[i];
            //printf("BEFORA : x=%g  y=%g\n", cloud_a[i].x, cloud_a[i].y);
        }else{
            merged_cloud[i]=cloud_b[i-(CLOUD_POINTS/3)];
            //printf("BEFORB : x=%g  y=%g\n", cloud_b[i-(CLOUD_POINTS/3)].x, cloud_b[i-(CLOUD_POINTS/3)].y);
        }
        //printf("MERGED : x=%g  y=%g\n\n", merged_cloud[i].x, merged_cloud[i].y);
    }
    return merged_cloud;
}

double error_diff(double m, double n){
    if(m>=n){
        return m-n;
    }else{
        return n-m;
    }
}

void error_diff_flag(double mistake){
    if(mistake>=ER){
        printf("\nThe difference between the 2 errors is BIGGER than the error rate :'(\n");
    }
    else{
        printf("\nThe difference between the 2 errors is SMALLER than the error rate :D\n");
    }
}

void cross_validation(Point* cloud0, Point* cloud1, Point* cloud2, double* a, double* b){
    int one_third = CLOUD_POINTS/3;
    int last_third = CLOUD_POINTS-(2*CLOUD_POINTS/3);
    int without_g3_size = (2*CLOUD_POINTS)/3;
    int with_g3_size = CLOUD_POINTS-(CLOUD_POINTS/3);
    double* current_cost; double cr = 0.0; current_cost=&cr;
    double model_cost, test_cost;
    Point* merged_1 = cloud_merger(cloud0, cloud1, false);
    Point* merged_2 = cloud_merger(cloud0, cloud2, true);
    Point* merged_3 = cloud_merger(cloud1, cloud2, true);
    double* c = malloc(sizeof(double));
    double* e = malloc(sizeof(double));
    double* g = malloc(sizeof(double));
    double* k = malloc(sizeof(double));
    double* m = malloc(sizeof(double));
    double* d = malloc(sizeof(double));
    double* f = malloc(sizeof(double));
    double* h = malloc(sizeof(double));
    double* l = malloc(sizeof(double));
    double* n = malloc(sizeof(double));
    *c=*a;*e=*a;*g=*a;*k=*a;*m=*a;*d=*b;*f=*b;*h=*b;*l=*b;*n=*b;

    //G1 U G2 et test sur G3
    printf("\n\n\nG1 U G2 et test sur G3\n");
    gradient_descent_v4(a, b, merged_1, without_g3_size, current_cost);
    printf("\nMODEL COST 1 = %g\n", *current_cost);
    model_cost=*current_cost;
    printf("A (Model 1) = %f || B (Model 1) = %f\n", *a, *b);
    gradient_descent_v4(c, d, cloud2, last_third, current_cost);
    printf("\nTEST  COST 1 = %g\n", *current_cost);
    test_cost=*current_cost;
    printf("A (Test  1) = %f || B (Test  1) = %f\n", *c,*d);
    double first_error_diff = error_diff(model_cost, test_cost);
    printf("\n1st Group Error Diff = %g", first_error_diff);
    error_diff_flag(first_error_diff);

    //G1 U G3 et test sur G2
    printf("\n\n\nG1 U G3 et test sur G2\n");
    gradient_descent_v4(e, f, merged_2, with_g3_size, current_cost);
    printf("\nMODEL COST 2 = %g\n", *current_cost);
    model_cost=*current_cost;
    printf("A (Model 2) = %f || B (Model 2) = %f\n", *e, *f);
    gradient_descent_v4(g, h, cloud1, one_third, current_cost);
    printf("\nTEST  COST 2 = %g\n", *current_cost);
    test_cost=*current_cost;
    printf("A (Test  2) = %f || B (Test  2) = %f\n", *g, *h);
    double second_error_diff = error_diff(model_cost, test_cost);
    printf("\n2nd Group Error Diff = %g", second_error_diff);
    error_diff_flag(second_error_diff);

    //G2 U G3 et test sur G1
    printf("\n\n\nG2 U G3 et test sur G1\n");
    gradient_descent_v4(k, l, merged_3, with_g3_size,current_cost);
    printf("\nMODEL COST 3 = %g\n", *current_cost);
    model_cost=*current_cost;
    printf("A (Model 3) = %f || B (Model 3) = %f\n", *k, *l);
    gradient_descent_v4(m, n, cloud0, one_third,current_cost);
    printf("\nTEST  COST 3 = %g\n", *current_cost);
    test_cost=*current_cost;
    printf("A (Test  3) = %f || B (Test  3) = %f\n", *m, *n);
    double third_error_diff = error_diff(model_cost, test_cost);
    printf("\n3rd Group Error Diff = %g", third_error_diff);
    error_diff_flag(third_error_diff);
    FILE *ab;
    ab = fopen ("ab.lines", "w+");
    fprintf(ab, "%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f",*a,*b,*c,*d,*e,*f,*g,*h,*k,*l,*m,*n);
    fclose(ab);

    free(merged_1);free(merged_2);free(merged_3);
    free(c);free(d);free(e);free(f);free(g);free(h);free(k);free(l);free(m);free(n);
}

void method_comparator(Point* clcloud, double* p, double* q){
    double* current_cost1; double cr1 = 0.0; current_cost1=&cr1;
    //Le a et le b calculé sur mon papier;
    double a_analytic = 0.16129417793;
    double b_analytic = 0.29677191;
    gradient_descent_v4(p, q, clcloud, CLOUD_POINTS, current_cost1);
    printf("\nMéthode analytique : A = %g et B = %g\n", a_analytic, b_analytic);
    printf("Méthode numérique : A = %g et B = %g\n", *p, *q);
    FILE *abb;
    abb = fopen ("comparator.lines", "w+");
    fprintf(abb, "%f\n%f\n%f\n%f",a_analytic,b_analytic,*p,*q);
    fclose(abb);
}

int main (void){
    srand(time(NULL));
    //a et b pour la droite de départ le long de laquelle les points vont être générés aléatoirement
    double a_init = double_random(MY_RAND_MIN,MY_RAND_MAX-RANDOMNESS);
    double b_init = double_random(MY_RAND_MIN,MY_RAND_MAX-RANDOMNESS);
    //Point* fluffy = cloud_test();
    double a = double_random(-100.0,100.0);
    double b = double_random(-100.0,100.0);
    //double p = double_random(-100.0,100.0);
    //double q = double_random(-100.0,100.0);

    //method_comparator(fluffy, &p, &q);
    
    Point* fluffy = cloud2_5(&a_init, &b_init);
    double current_costt=0.0;
    gradient_descent_v4(&a, &b, fluffy, CLOUD_POINTS, &current_costt);
    Point** cloud_slayer = cloud_splitter(fluffy);

    cross_validation(cloud_slayer[0], cloud_slayer[1], cloud_slayer[2], &a, &b);
    free(cloud_slayer);
    free(fluffy);
    return 0;
}
